library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

use work.am2901_comp.all;
use work.am2901_mnemonics.all;

entity q_register is
  generic (
    WIDTH      :     integer := 4);
  port (
    Clock_in   : in  std_logic;
    Q_Shift_in : in  std_logic_vector((WIDTH - 1) downto 0);
    Q_out      : out std_logic_vector((WIDTH - 1) downto 0));

end q_register;

architecture arch_q_register of q_register is

  signal Clock   : std_logic;
  signal Q_Shift : std_logic_vector((WIDTH - 1) downto 0);
  signal Q       : std_logic_vector((WIDTH - 1) downto 0);

begin  -- arch_q_register

  Clock   <= Clock_in;
  Q_Shift <= Q_Shift_in;

  Q_out <= Q;

  U1 : process (Clock)
  begin  -- process U1

    if Clock'event and Clock = '1' then  -- rising clock edge

      Q <= Q_Shift;

    end if;
  end process U1;

end arch_q_register;
