library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;
use work.am2910_comp.all;

entity program_counter is
  port (
    Clock_in : in  std_logic;
    D_in     : in  std_logic_vector(11 downto 0);
    Q_out    : out std_logic_vector(11 downto 0));
end program_counter;

architecture arch_program_counter of program_counter is

  signal Clock : std_logic;
  signal D     : std_logic_vector(11 downto 0);
  signal Q     : std_logic_vector(11 downto 0);

begin

  Clock <= Clock_in;
  D     <= D_in;

  Q_out <= Q;

  U1 : process (Clock)
  begin
    if (Clock'event and Clock = '1') then

      Q <= D;

    end if;  -- if (Clock'event and Clock = '1')

  end process U1;

end arch_program_counter;
