library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;
use work.am2910_comp.all;

entity reg_count is
  port (
    Clock_in       : in  std_logic;
    Direct_Load_in : in  std_logic;
    Decr_En_in     : in  std_logic;
    Load_En_in     : in  std_logic;
    D_in           : in  std_logic_vector(11 downto 0);
    Q_out          : out std_logic_vector(11 downto 0));
end reg_count;

architecture arch_reg_count of reg_count is

  signal Clock       : std_logic;
  signal Direct_Load : std_logic;
  signal Decr_En     : std_logic;
  signal Load_En     : std_logic;
  signal D           : std_logic_vector(11 downto 0);
  signal Q           : std_logic_vector(11 downto 0);

begin

  Clock       <= Clock_in;
  Direct_Load <= Direct_Load_in;
  Decr_En     <= Decr_En_in;
  Load_En     <= Load_En_in;
  D           <= D_in;

  Q_out <= Q;

  U1 : process (Clock)
  begin
    if (Clock'event and Clock = '1') then
      if (Direct_Load = '1' or Load_En = '1') then

        Q <= D;

      elsif (Decr_En = '1') then

        Q <= Q - 1;

      end if;  -- if (Direct_Load = '1' or Load_En = '1')

    end if;  -- if (Clock'event and Clock = '1')

  end process U1;

end arch_reg_count;
