library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

use work.User_App_comp.all;

entity IO_Decoder is

  port (
    IO_Address_in  : in  std_logic_vector(15 downto 0);
    IORD_in        : in  std_logic;
    IOWR_in        : in  std_logic;
    IO_Sel_out     : out std_logic;
    IOWait_out     : out std_logic;
    DISP_WR_out    : out std_logic;
    Int_Gen_RD_out : out std_logic);

end IO_Decoder;

architecture arch_IO_Decoder of IO_Decoder is

  signal IO_Address : std_logic_vector(15 downto 0);
  signal IORD       : std_logic;
  signal IOWR       : std_logic;
  signal IO_Sel     : std_logic;
  signal IOWait     : std_logic;
  signal DISP_WR    : std_logic;
  signal Int_Gen_RD : std_logic;

begin  -- arch_IO_Decoder

  IO_Address <= IO_Address_in;
  IORD       <= IORD_in;
  IOWR       <= IOWR_in;

  IO_Sel_out     <= IO_Sel;
  IOWait_out     <= IOWait;
  DISP_WR_out    <= DISP_WR;
  Int_Gen_RD_out <= Int_Gen_RD;

  IOWait <= '1';

  IO_Sel <= '0' when (IO_Address = X"0010") else
            '1' when (IO_Address = X"0020") else
            '0';

  DISP_WR <= '1' when ((IO_Address = X"0010") and IOWR = '1') else
             '0';

  Int_Gen_RD <= '1' when ((IO_Address = X"0030") and IORD = '1') else
                '0';

end arch_IO_Decoder;
