library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

use work.User_App_comp.all;

entity Interrupt_Gen is

  port (
    Clock_in      : in  std_logic;
    Reset_in      : in  std_logic;
    Enable_in     : in  std_logic;
    Int_Gen_RD_in : in  std_logic;
    Int_out       : out std_logic);
end Interrupt_Gen;

architecture arch_Interrupt_Gen of Interrupt_Gen is

  signal Clock      : std_logic;
  signal Reset      : std_logic;
  signal Enable     : std_logic;
  signal Int_Gen_RD : std_logic;
  signal Int        : std_logic;

begin  -- arch_Interrupt_Gen

  Clock      <= Clock_in;
  Reset      <= Reset_in;
  Enable     <= Enable_in;
  Int_Gen_RD <= Int_Gen_RD_in;

  Int_out <= Int;

  U1 : process (Clock, Reset)
  begin
    if Reset = '1' then

      Int <= '0';

    elsif Clock'event and Clock = '1' then
      if Enable = '1' and Int_Gen_RD = '0' then

        Int <= '1';

      elsif Enable = '0' and Int_Gen_RD = '1' then

        Int <= '0';

      elsif Enable = '1' and Int_Gen_RD = '1' then

        Int <= not Int;

      else

        Int <= Int;

      end if;  -- if Enable = '1' and Int_Gen_RD = '0'
    end if;  -- if Reset = '1'

  end process U1;

end arch_Interrupt_Gen;
