library ieee;

use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

package S3_IF_comp is

  component IBUFG
    port (
      O : out std_logic;
      I : in  std_logic);
  end component;

  component BUFG
    port (
      O : out std_logic;
      I : in  std_logic);
  end component;

  component CLK_IF
    port (
      CLK_50MHZ_input  : in  std_logic;
      CLK_AUX_input    : in  std_logic;
      CLK_50MHZ_output : out std_logic;
      CLK_AUX_output   : out std_logic);
  end component;

  component SW_IF
    port (
      Slider_Switch_input  : in  std_logic_vector(7 downto 0);
      PB_Switch_input      : in  std_logic_vector(3 downto 0);
      Slider_Switch_output : out std_logic_vector(7 downto 0);
      PB_Switch_output     : out std_logic_vector(3 downto 0));
  end component;

  component LED_IF
    port (
      LED_input  : in  std_logic_vector(7 downto 0);
      LED_output : out std_logic_vector(7 downto 0));
  end component;

  component DISP_IF
    port (
      Segment_A_input   : in  std_logic;
      Segment_B_input   : in  std_logic;
      Segment_C_input   : in  std_logic;
      Segment_D_input   : in  std_logic;
      Segment_E_input   : in  std_logic;
      Segment_F_input   : in  std_logic;
      Segment_G_input   : in  std_logic;
      Segment_DP_input  : in  std_logic;
      Segment_AN_input  : in  std_logic_vector(3 downto 0);
      Segment_A_output  : out std_logic;
      Segment_B_output  : out std_logic;
      Segment_C_output  : out std_logic;
      Segment_D_output  : out std_logic;
      Segment_E_output  : out std_logic;
      Segment_F_output  : out std_logic;
      Segment_G_output  : out std_logic;
      Segment_DP_output : out std_logic;
      Segment_AN_output : out std_logic_vector(3 downto 0));
  end component;

  component User_App
    port (
      CLK_50MHZ_in     : in  std_logic;
      CLK_AUX_in       : in  std_logic;
      Reset_in         : in  std_logic;
      Slider_Switch_in : in  std_logic_vector(7 downto 0);
      PB_Switch_in     : in  std_logic_vector(3 downto 0);
      LED_out          : out std_logic_vector(7 downto 0);
      Segment_A_out    : out std_logic;
      Segment_B_out    : out std_logic;
      Segment_C_out    : out std_logic;
      Segment_D_out    : out std_logic;
      Segment_E_out    : out std_logic;
      Segment_F_out    : out std_logic;
      Segment_G_out    : out std_logic;
      Segment_DP_out   : out std_logic;
      Segment_AN_out   : out std_logic_vector(3 downto 0));
  end component;

end S3_IF_comp;
