library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity mux_2to1b is

  port (
    D0_in         : in  std_logic;
    D1_in         : in  std_logic;
    Mux_Select_in : in  std_logic;
    Mux_out       : out std_logic);

end mux_2to1b;

architecture arch_mux_2to1b of mux_2to1b is

  signal D0         : std_logic;
  signal D1         : std_logic;
  signal Mux_Select : std_logic;
  signal Mux        : std_logic;

begin  -- arch_mux_2to1b

  D0         <= D0_in;
  D1         <= D1_in;
  Mux_Select <= Mux_Select_in;

  Mux_out <= Mux;

  Mux <= D0 when Mux_Select = '0' else
         D1 when Mux_Select = '1' else
         '0';

end arch_mux_2to1b;
